%define releasebase 3
#Use as deafults if no command line inputs
%define as_limulus 1
# allow --with[out] <feature> at rpm command line build
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%if "1" == "%{as_limulus}"
%define targetbase Limulus
%endif
%endif




Summary: USB relay control program
name: relayset
Version:0.3
Group: %{targetbase}/Admin
Release: %{releasebase}.%{targetbase}
License: GPL
Source: %{name}-%{version}.tgz
URL: www.basement-supercomputing.com
Distribution: various
Vendor: Basement Supercompting
Packager: deadline@basement-supercomputing.com
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}
BuildREquires: libftdi-devel
Requires: libftdi, pdsh
ExclusiveOS: linux

%description
Provides control of TCTEC USB relay board for Limulus systems. Can use mulitple boards.
%prep 
%setup -n relayset
%build
gcc relayset.c -g -ldl -lftdi -o relayset
%install
/bin/mkdir -p $RPM_BUILD_ROOT/usr/sbin
/bin/cp relayset $RPM_BUILD_ROOT/usr/sbin
chmod 744 $RPM_BUILD_ROOT/usr/sbin/relayset
/bin/cp bright-relayset $RPM_BUILD_ROOT/usr/sbin
chmod 744 $RPM_BUILD_ROOT/usr/sbin/bright-relayset
/bin/cp node-poweron $RPM_BUILD_ROOT/usr/sbin/node-poweron
chmod 744 $RPM_BUILD_ROOT/usr/sbin/node-poweron
/bin/cp node-poweroff $RPM_BUILD_ROOT/usr/sbin/node-poweroff
chmod 744 $RPM_BUILD_ROOT/usr/sbin/node-poweroff
/bin/mkdir -p $RPM_BUILD_ROOT/etc/warewulf/.%{targetbase}/
cp limulus-map-node  $RPM_BUILD_ROOT/etc/warewulf/.%{targetbase}/limulus-map-node
chmod 744 $RPM_BUILD_ROOT/etc/warewulf/.%{targetbase}/limulus-map-node

%pre
# If this is an upgrade, remove the the init script from rc.local
if [ $1 -eq 2 ] ; then
  grep -v  RELAYSET  /etc/rc.d/rc.local>/var/tmp/rc.local
  /bin/cp /var/tmp/rc.local /etc/rc.d/rc.local
  /bin/rm /var/tmp/rc.local
fi

%post
cat << EOF >> /etc/rc.d/rc.local
# Added by Basement for RELAYSET 
if [ -e "/usr/sbin/relayset" ] ; then                                                         #RELAYSET
 if [ -e "/etc/warewulf/.Limulus/relayboardID" ]; then                                        #RELAYSET        
  BOARDS=\`cat /etc/warewulf/.Limulus/relayboardID\`                                            #RELAYSET
  for I in \$BOARDS; do  /usr/sbin/relayset init \$I;                                           #RELAYSET
   if [ \$? -ne 0 ] ; then echo "<3>Relayset: Initialization FAILED for board \$I." > /dev/kmsg #RELAYSET
   else  echo "<6>Relayset: Initialization SUCCESS for board \$I." > /dev/kmsg; fi; done       #RELAYSET
 else /usr/sbin/relayset init;                                                                #RELAYSET
  if [ \$? -ne 0 ] ; then echo "<3>Relayset: Initialization FAILED." > /dev/kmsg               #RELAYSET
  else  echo "<6>Relayset: Initialization SUCCESS." > /dev/kmsg; fi ; fi                      #RELAYSET
else echo '<3>Relayset: relayset not found.' > /dev/kmsg ; fi                                 #RELAYSET
EOF
%postun
# If ununstall remove init script
if [ $1 -eq 0 ] ; then
  grep -v  RELAYSET  /etc/rc.d/rc.local>/var/tmp/rc.local
  /bin/cp /var/tmp/rc.local /etc/rc.d/rc.local
  /bin/rm /var/tmp/rc.local
fi

%clean
if [ $RPM_BUILD_ROOT != "/" ]; then
  rm -rf $RPM_BUILD_ROOT
fi
%files
%defattr(-,root,root)
/usr/sbin/relayset
/usr/sbin/bright-relayset
/usr/sbin/node-poweron
/usr/sbin/node-poweroff
/etc/warewulf/

%changelog
* Tue May 30 2017  Douglas Eadline <deadline@basement-supercomputing.com>
- Added changes to use multple relay boards bases on board ID, the relayset.c
* Sun Jan 29 2017  Douglas Eadline <deadline@basement-supercomputing.com>
- To ensure nodes always shutdown, make pdsh in node-poweroff run as separate process, so it cannot freeze node shutdown
* Sun Aug 14 2016  Douglas Eadline <deadline@basement-supercomputing.com>
- added time out to read in node-poweron so script does not get stuck
* Tue Mar 15 2016  Douglas Eadline <deadline@basement-supercomputing.com>
- updated  node-poweron/off script in case wwsh is not present, 
- assumes /etc/warewulf/.Limulus/actual-nodes, increased off timeout to 30
* Wed Jan 28 2015  Douglas Eadline <deadline@basement-supercomputing.com>
- updated better node-poweron/off script, put things in /usr/sbin
* Sun Jan 06 2013  Douglas Eadline <deadline@basement-supercomputing.com>
- added dummy relay numbers 5,6,7,8 for expansion 
- added node-poweron, node-poweroff, limulus-map-node for better node control
* Tue Jul 24 2012  Douglas Eadline <deadline@basement-supercomputing.com>
- created

